#if !defined( __NEWLIB__ )
  #define __NEWLIB__

/****************************************************************************
 NEWLIB.H

 Headerfile zur Fenster- und Grafikbibliothek

 (C)1991-1996 Carsten Setje-Eilers
              Aschauweg 18a
              24116 Kiel-Kronshagen
              Telefon 0431/544716
              Telefax 0431/547212
 ****************************************************************************/

/********** DEFINES *********************************************************/

#ifndef NOMYDIALS
	#define DREID
	#define mydials          /* fuer mydial-init und exit          */
	#define mydial_popup     /* mydial-popups benutzen             */
	#define mydial_alert     /* mydial-form-alert benutzen (doof!) */
#endif

#ifdef kasse
	#undef KASSE
	#define KASSE
#endif

#ifndef TRUE
  typedef enum{ FALSE, TRUE } boolean;
#endif

#ifndef boolean
  #define boolean BOOLEAN
#endif

/********** TYPEDEFINES *****************************************************/
typedef unsigned long DWORD;

#define INT     int                           /* A machine dependent int     */
#define UINT    unsigned int                  /* A machine dependent uint    */
#define LONG    long                          /* Signed long (32 bits)       */
#define ULONG   unsigned long                 /* Unsigned long               */

#define LOBYTE(w)	    ((BYTE)(w))
#define HIBYTE(w)     ((BYTE)(((UINT)(w) >> 8) & 0xFF))

#define LOWORD(l)     ((WORD)(DWORD)(l))
#define HIWORD(l)     ((WORD)((((DWORD)(l)) >> 16) & 0xFFFF))

#define MAKELONG(low, high) ((LONG)(((WORD)(low)) | (((DWORD)((WORD)(high))) << 16)))

typedef UINT WPARAM;
typedef LONG LPARAM;
typedef LONG LRESULT;

#define MAKELPARAM(low, high)	((LPARAM)MAKELONG(low, high))
#define MAKELRESULT(low, high)	((LRESULT)MAKELONG(low, high))

/********** INCLUDES ********************************************************/
#include <portab.h>
#include <tos.h>
#include <aes.h>
#include <vdi.h>

#define NDEBUG
#include <assert.h>

#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <math.h>
#include <tos.h>
#include <stdio.h>
#include <scancode.h>
#include <ctype.h>
#include <errno.h>

#include <mglobal.h>
#include <mydial.h>
#include <nkcc.h>


/********** DEFINES *********************************************************/
#define XACC
#define TOOLBAR

#define SPEZIALEDIT      /* Cursor steht rechts (fr DM-Felder */
#define PICTUREWIN

#ifdef PICTUREWIN
  #include<graflib.h>
#endif

#define slidersize   RtSliderSize
#define slider       RtSlider

/* Windows Kompatibilitaeten */
#define  WM_PAINT          WM_REDRAW
#define  HWND              WORD
#define  HRGN              VOID *
#define  RDW_INTERNALPAINT WM_PAINT

#define  WM_SHADED         22360
#define  WM_UNSHADED       22361

#define  WM_CTLCOLOR       17261
#define  WM_GETCOLOR       17261 /* kompatibel! */

#define  WM_GETFONTID      17262
#define  WM_SETFONTID      17263
#define  WM_GETFONTSIZE    17264
#define  WM_SETFONTSIZE    17265
#define  WM_GETICON        17266
#define  WM_SETCOLOR       17267
#define  FONT_CHANGED      0x7a18

typedef INT  ( *EVENTFUNC )( HWND hwnd, INT objc, INT clicks );
typedef VOID ( *MENUEVENTFUNC )( HWND hwnd, INT msgbuf[] );
typedef VOID ( *REDRAWFUNC )( HWND hwnd , INT drawflag, INT x, INT y, INT w, INT h );
typedef VOID ( *MOUSEEVENTFUNC )( HWND, INT, INT, INT);
typedef VOID ( *RTSCROLL )( HWND, INT, INT );

/****************************************************************************
 Systemvariablen

 ****************************************************************************/
#define  phystop             0x42E   /* oberes freies RAM-Ende              */
#define  conterm             0x484   /* Systemvariable fuer Click und Bell an/aus */
#define  _hz_200             0x4BA   /* 200 Hz-Timer                        */
#define  Sync_mode_register  0xFFFF820AL   /* Videocontroller (50/60Hz)     */
#define  _sysbase            0x4F2   /* Startadresse OS                     */
#define  _fverify            0x444   /* Floppyverify                        */
#define  seekrate            0x440   /* Floppysteprate                      */
#define  _bootdev            0x446   /* Bootlaufwerk:long-Wert!!!)          */
#define  _drivebits          0x4C2   /* vorhandene Laufwerke                */
#define  _nflops             0x4A6   /* Anzahl der Floppylaufw.             */

/****************************************************************************
 Diverse Makros, die das Leben leichter machen

 ****************************************************************************/

#ifdef DREID
  /* Mydial 3D-Look-Userdefs werden beachtet durch get_obspec */

	#define ObFlags( tree, obj )		 		( tree[( obj )].ob_flags )
	#define ObState( tree, obj )			 	( tree[( obj )].ob_state )
	#define ObType( tree, obj )	    		( tree[( obj )].ob_type )

	#define TedText( tree, obj )		 	  (((TEDINFO *)get_obspec( tree, obj ))->te_ptext )
	#define TedPos( tree, obj )		  	  (((TEDINFO *)get_obspec( tree, obj ))->te_junk2 )
	#define TedTemp( tree, obj )  			(((TEDINFO *)get_obspec( tree, obj ))->te_ptmplt )
	#define TedLen( tree, obj )    			(((TEDINFO *)get_obspec( tree, obj ))->te_txtlen )
	#define TedTempLen( tree, obj )			(((TEDINFO *)get_obspec( tree, obj ))->te_tmplen )
  #define TedValid( tree, obj )	    	(((TEDINFO *)get_obspec( tree, obj ))->te_pvalid )
	#define TedJust( tree,obj )	    		(((TEDINFO *)get_obspec( tree, obj ))->te_just )
	#define TedFont( tree,obj ) 	  		(((TEDINFO *)get_obspec( tree, obj ))->te_font )
	#define TedColor( tree,obj ) 	  		(((TEDINFO *)get_obspec( tree, obj ))->te_color )

	#define Check( tree, obj )				  ( ObState( tree, obj ) |= CHECKED )
	#define DeCheck( tree, obj )				( ObState( tree, obj ) &= ~CHECKED )
	#define Select( tree, obj )				  ( ObState( tree, obj ) |= SELECTED )
	#define DeSelect( tree, obj )				( ObState( tree, obj ) &= ~SELECTED )
	#define Disable( tree, obj )				( ObState( tree, obj ) |= DISABLED )
	#define Enable( tree, obj )					( ObState( tree, obj ) &= ~DISABLED )

	#define ObNext( tree, obj )  				( tree[( obj )].ob_next )
	#define ObHead( tree, obj )			  	( tree[( obj )].ob_head )
	#define ObTail( tree, obj )			  	( tree[( obj )].ob_tail )

	#define UbCode( tree, obj )					(((USERBLK *)get_obspec( tree, obj ))->ub_code )
	#define UbParm( tree, obj )					(((USERBLK *)get_obspec( tree, obj ))->ub_parm )

	#define UserString( tree, obj )			((char *)UbParm( tree, obj ))
	#define ObString( tree, obj )				((char *)get_obspec( tree, obj ))

	#define ObX( tree, obj ) 						( tree[( obj )].ob_x )
	#define ObY( tree, obj ) 						( tree[( obj )].ob_y )
	#define ObW( tree, obj )						( tree[( obj )].ob_width )
	#define ObH( tree, obj ) 					  ( tree[( obj )].ob_height )
	#define ObRect( tree, obj ) 				( *(GRECT *)(&( tree[( obj )].ob_x)) )

	#define BitblkX( tree, obj )   			(((BITBLK *)get_obspec( tree, obj ))->bi_x )
	#define BitblkY( tree, obj )		    (((BITBLK *)get_obspec( tree, obj ))->bi_y )
	#define BitblkW( tree, obj )		    (((BITBLK *)get_obspec( tree, obj ))->bi_wb )
	#define BitblkH( tree, obj )    		(((BITBLK *)get_obspec( tree, obj ))->bi_hl )
	#define BitblData( tree, obj )   		(((BITBLK *)get_obspec( tree, obj ))->bi_pdata )
	#define BitblkColor( tree, obj ) 		(((BITBLK *)get_obspec( tree, obj ))->bi_color )


	#define IconblkX( tree, obj )   		(((ICONBLK *)get_obspec( tree, obj ))->ib_xicon )
	#define IconblkY( tree, obj )   		(((ICONBLK *)get_obspec( tree, obj ))->ib_yicon )
	#define IconblkW( tree, obj )   		(((ICONBLK *)get_obspec( tree, obj ))->ib_wicon )
	#define IconblkH( tree, obj ) 		  (((ICONBLK *)get_obspec( tree, obj ))->ib_hicon )
	#define IconBlkText( tree, obj )	  (((ICONBLK *)get_obspec( tree, obj ))->ib_ptext	)
	#define IconBlkChar( tree, obj )	  (((ICONBLK *)get_obspec( tree, obj ))->ib_char )

	#define IsSelected( tree, obj )			( ObState( tree, obj ) & SELECTED )
	#define IsEditable( tree, obj )			( ObFlags( tree, obj ) & EDITABLE )
	#define IsHidden( tree, obj )			  ( ObFlags( tree, obj ) & HIDETREE )
	#define IsSpecial( tree, obj )			( ObState( tree, obj ) & SPECIAL  )
	#define IsDisabled( tree, obj )			( ObState( tree, obj ) & DISABLED )
	#define IsChecked( tree, obj )			( ObState( tree, obj ) & CHECKED )

	#define HideObj( tree, obj )				( ObFlags( tree, obj ) |= HIDETREE )
	#define ShowObj( tree, obj )				( ObFlags( tree, obj ) &= ~HIDETREE )
	#define MakeEditable( tree, obj )  	( ObFlags( tree, obj ) |= EDITABLE )
	#define NoEdit( tree, obj )					( ObFlags( tree, obj ) &= ~EDITABLE )
	#define MarkObj( tree, obj )				( ObState( tree, obj ) |= SPECIAL  )
	#define UnmarkObj( tree, obj )			( ObState( tree, obj ) &= ~SPECIAL  )
	#define SetNormal( tree, obj )			( ObState( tree, obj ) = NORMAL	   )
	#define MakeDefault( tree, obj )	 	( ObFlags( tree, obj ) |= DEFAULT )
	#define NoDefault( tree, obj )			( ObFlags( tree, obj ) &= ~DEFAULT )
	#define MakeExit(  tree, obj  )			( ObFlags( tree, obj ) |= EXIT )
	#define NoExit(  tree, obj  )				( ObFlags( tree, obj ) &= ~EXIT )
	#define MakeSelect(  tree, obj  )  	( ObFlags( tree, obj ) |= SELECTABLE )
	#define NoSelect(  tree, obj  )	   	( ObFlags( tree, obj ) &= ~SELECTABLE )

  #define FrameSize( tree, obj )      (get_bfobspec( tree, obj )->framesize )
  #define FillPattern( tree, obj )    (get_bfobspec( tree, obj )->fillpattern )
  #define InteriorCol( tree, obj )    (get_bfobspec( tree, obj )->interiorcol )

  #define Index( tree, obj )          (get_obspec( tree, obj ))
  #define FreeString( tree, obj )     ((char *)get_obspec( tree, obj ))

#else

  #define ObSpec(tree,obj)	  	( tree[(obj)].ob_spec )
	#define ObFlags(tree,obj) 		( tree[(obj)].ob_flags )
	#define ObState(tree,obj)	  	( tree[(obj)].ob_state )
	#define ObType(tree,obj)	  	( tree[(obj)].ob_type )

	#define TedText(tree,obj)	  	( ObSpec( tree, obj ).tedinfo->te_ptext )
	#define TedTemp(tree,obj)	  	( ObSpec( tree, obj ).tedinfo->te_ptmplt )
	#define TedLen(tree,obj)    	( ObSpec( tree, obj ).tedinfo->te_txtlen )
	#define TedTempLen(tree,obj)	( ObSpec( tree, obj ).tedinfo->te_tmplen )

	#define Select(tree,obj)			( ObState(tree,obj) |= SELECTED )
	#define DeSelect(tree,obj)		( ObState(tree,obj) &= ~SELECTED )
	#define Disable(tree,obj)			( ObState(tree,obj) |= DISABLED )
	#define Enable(tree,obj)			( ObState(tree,obj) &= ~DISABLED )

	#define ObNext(tree,obj)  		( tree[(obj)].ob_next )
	#define ObHead(tree,obj)	  	( tree[(obj)].ob_head )
	#define ObTail(tree,obj)	  	( tree[(obj)].ob_tail )

	#define TedJust( tree,obj )	  ( ObSpec( tree, obj ).tedinfo->te_just )
	#define TedFont( tree,obj ) 	( ObSpec( tree, obj ).tedinfo->te_font )
	#define TedColor( tree,obj) 	( ObSpec( tree, obj ).tedinfo->te_color )

	#define UserString(tree,obj)	((char *)ObSpec( tree, obj ).userblk->ub_parm )
	#define ObString(tree,obj)		( ObSpec( tree, obj ).free_string )

	#define ObX(tree,obj) 				( tree[(obj)].ob_x )
	#define ObY(tree,obj) 				( tree[(obj)].ob_y )
	#define ObW(tree,obj)				 	( tree[(obj)].ob_width )
	#define ObH(tree,obj) 				( tree[(obj)].ob_height )
	#define ObRect(tree,obj)			( *(GRECT *)(&(tree[(obj)].ob_x)) )

	#define BitblkX(tree,obj)     ( ObSpec( tree, obj ).bitblk->bi_x )
	#define BitblkY(tree,obj)     ( ObSpec( tree, obj ).bitblk->bi_y )
	#define BitblkW(tree,obj)     ( ObSpec( tree, obj ).bitblk->bi_wb )
	#define BitblkH(tree,obj)     ( ObSpec( tree, obj ).bitblk->bi_hl )

	#define IconblkX(tree,obj)    ( ObSpec( tree, obj ).iconblk->ib_xicon )
	#define IconblkY(tree,obj)    ( ObSpec( tree, obj ).iconblk->ib_yicon )
	#define IconblkW(tree,obj)    ( ObSpec( tree, obj ).iconblk->ib_wicon )
	#define IconblkH(tree,obj)    ( ObSpec( tree, obj ).iconblk->ib_hicon )

	#define IsSelected(tree,obj)	( ObState(tree,obj) & SELECTED )
	#define IsEditable(tree,obj)	( ObFlags(tree,obj) & EDITABLE )
	#define IsSpecial(tree,obj)		( ObState(tree,obj) & SPECIAL  )
	#define IsDisabled(tree,obj)	( ObState(tree,obj) & DISABLED )
	#define IsHidden(tree,obj)	  ( ObState(tree,obj) & HIDETREE )

	#define HideObj(tree,obj)			( ObFlags(tree,obj) |= HIDETREE )
	#define ShowObj(tree,obj)			( ObFlags(tree,obj) &= ~HIDETREE )
	#define MakeEditable(tree,obj)( ObFlags(tree,obj) |= EDITABLE )
	#define NoEdit(tree,obj)			( ObFlags(tree,obj) &= ~EDITABLE )
	#define MarkObj(tree,obj)			( ObState(tree,obj) |= SPECIAL  )
	#define UnmarkObj(tree,obj)		( ObState(tree,obj) &= ~SPECIAL  )
	#define SetNormal(tree,obj)		( ObState(tree,obj) = NORMAL	   )
	#define MakeDefault(tree,obj)	( ObFlags(tree,obj) |= DEFAULT )
	#define NoDefault(tree,obj)		( ObFlags(tree,obj) &= ~DEFAULT )
	#define MakeExit( tree,obj )	( ObFlags(tree,obj) |= EXIT )
	#define NoExit( tree,obj )		( ObFlags(tree,obj) &= ~EXIT )
	#define MakeSelect( tree,obj )( ObFlags(tree,obj) |= SELECTABLE )
	#define NoSelect( tree,obj )	( ObFlags(tree,obj) &= ~SELECTABLE )

  #define FrameSize( tree, obj )  ( ObSpec( tree, obj ).obspec.framesize )
#endif

/****************************************************************************
 Definitionen

 ****************************************************************************/
#ifndef max
#ifndef mydials
  #define min( a , b ) ((a) < (b) ? (a) : (b))
  #define max( a , b ) ((a) > (b) ? (a) : (b))
#endif
#endif

#define  DESK          0
#define  MultiAES()    ( _GemParBlk.global[ 1 ] != 1 )
#define  AESVersion    _GemParBlk.global[0]
#define  ap_count      _GemParBlk.global[1]
#define  wchar         gl_x
#define  hchar         gl_y
#define  wbox          gl_w
#define  hbox          gl_h
#define  FULLWIN       NAME|CLOSER|MOVER|FULLER|INFO|SIZER|UPARROW|DNARROW|VSLIDE|LFARROW|RTARROW|HSLIDE|SMALLER
#define  DIALWIN       NAME|CLOSER|MOVER|SMALLER
#define  ALERTWIN      NAME|MOVER
#define  VERT_SLIDER   1
#define  HORT_SLIDER   !VERT_SLIDER

#define  DRUCKER       10
#define  WORDPLUS      11
#define  STEUERZEICHEN 12
#define  SPEEDO        13
#define  DATEI         20
#define  FENSTER       30

#define  FSEL          1
#define  NOFSEL        !FSEL
#define  CLEAR         0
#define  DISK          1
#define  TASSE         2
#define  BALL1         3
#define  BALL2         4
#define  BALL3         5
#define  BALL4         6
#define  STOP          7
#define  FMD_BACKWARD -1
#define  FMD_FORWARD  -2
#define  FMD_DEFLT    -3
#define  NIL         (-1)
#define  THEBAR        1                     /* Objekt-Nummer der Menzeile */
#define  THEACTIVE     2                     /* Objekt-Nummer der aktiven Mens */
#define  THEFIRST      3                     /* Objekt-Nummer des ersten Mens */
#define  DIALOG        0
#define  BILD          1
#define  TEXT          2
#define  XACCKEY       1
#define  KEYBRD        0
#define  WF_WINX       22360
#define  BOOL          BOOLEAN
#define  EINVFN        -32

#define  ClearScreen() puts( "\33H" );

/* X_ACC Definitionen */
#define  ACC_ID          0x400
#define  ACC_OPEN        0x401
#define  ACC_CLOSE       0x402
#define  ACC_ACC         0x403
#define  ACC_EXIT        0x404
#define  ACC_ACK         0x500
#define  ACC_TEXT        0x501
#define  ACC_KEY         0x502
#define  ACC_META        0x503
#define  ACC_IMG         0x504

/* AV-Protokoll */
#define VA_START         0x4711
#define AV_SENDKEY       0x4710
#define AV_ACCWINDOPEN   0x4724
#define AV_ACCWINDCLOSED 0x4726

/****************************************************************************/
typedef char appname[26];

typedef struct _xapps{        /* Feld, um sich die XAcc-Daten zu merken */
  appname app_name[7];        /* beachte Typ appname -> name ist 26 lang */
  int     version[7];
  int     menu_id[7];
  int     app_id[7];
}XAPPS;

/****************************************************************************
 Extended Objects

 ****************************************************************************/
#define  BIGBUTTON           512       /* flag  9 */
#define  TITLE               1024      /*      10 */
#define  BOX                 2048      /*      11 */
#define  THREEDOWN           4096      /*      12 */
#define  THREEUP             8192      /*      13 */
#define  LEFTEDIT             256      /* state 8 */
#define  RIGHTEDIT            512      /*       9 */
#define  SPEZIAL             1024      /*      10 */
#define  MENGENFELD          2048      /*      11 */

/****************************************************************************
 Schnittstelle der NEWLIB

 ****************************************************************************/
typedef struct{
  /* Externe Funktionen - sollten auch eingetragen werden! */
  void ( *EndFunc )( void );
  void ( *MenuEvent )( HWND, int msgbuf[] );
  void ( *TimerEvent )( void );
  int  ( *KeyEvent )( HWND hwnd, KEYTAB *keytab, int kb, int keycode );
  void ( *AccCloseEvent )( void );
  void ( *AccOpenEvent )( void );
  void ( *XaccUpdate )( void );
  void ( *VA_Start )( char *cmd );
  WORD ( *Alert )( WORD nr, BYTE *file );
  VOID ( *MenuEntries )( OBJECT *menu );
  INT  ( *RButtonEvent )( INT mx, INT my, INT clicks );

  /* Externe Funktionen - muessen nicht  eingetragen werden!       */
  void ( *user_r_or_l_edit )(HWND hwnd );
  void ( *IsEdit )( HWND hwnd );         /* wenn Taste gedrueckt wurde */
  int  ( *CloseWindow )( int );          /* vorm Fensterschlieen      */

  /* Interne Funktionen - koennen natuerlich ueberschrieben werden */
  INT ( *ButtonEvent )( INT *, INT *, INT *, INT * );

  /* Wichtige Daten */
  OBJECT *menutree;   /* Menuebaum                   */
  OBJECT *icontree;   /* Baum frs Iconifizieren     */
  OBJECT *icons;      /* Baum fr die Farbicons      */
  OBJECT *fontbox;    /* Zeichensatzauswahlbox       */

  int  flags;         /* Bit 0: Wert 1: Druckerport bereit per Cprnos() pruefen */

  int  IconHandle;    /* Nr des Default Icons beim Iconify **/
  int  timer;         /* Timerevent                  */
  int  menu_id;       /* Nr. des eigenen ACC-Slots   */
  int  xacc_id;       /* XAcc-Version                */
  char *name;         /* Zeiger auf lesbaren Buffer mit Namen des Programmes         */
}NL;

/****************************************************************************
 Fontinfostruktur

 ****************************************************************************/
typedef struct{
  int height_ibm;    /* IBM-Font */
  int points_ibm;
  int id_ibm;

  int height_small;  /* Small-Font */
  int points_small;
  int id_small;

  int fontcount;
}FONT;

/****************************************************************************
 1stWord-Treiber

 ****************************************************************************/
typedef enum{
  CRLF=1, DBON=6, DBOFF, NBON, NBOFF, DION, DIOFF,
  NION, NIOFF, DDUON, DDUOFF, NDUON, NDUOFF, DSUPON,
  DSUPOFF, NSUPON, NSUPOFF, DSUBON,
  DSUBOFF, NSUBON, NSUBOFF, DUON, DUOFF, NUON, NUOFF, _FF, HINIT, VINIT,
  TERMINATE, _BS, _CR, FLEN, LFEED,
  SGRAF, RESV, DPICA, NPICA, DELITE, NELITE, DCOND, NCOND, DEXP, NEXP
}CFG_CTRLS;

/****************************************************************************
 Extern benutzbare Variablen

 ****************************************************************************/
extern NL      nl;
extern WORD    *d_pattern, *d_colour, *d_look, *dropdown, config[128], md_handle,
               vwk_handle;
extern WORD    gl_x, gl_y, gl_w, gl_h;
extern GRECT   desk, t1;
extern int     has_fsm, has_speedo, has_appl_getinfo, has_iconify, UseWinalert,
               has_bevent, has_AP_TERM, has_mint, has_nvdi, has_Magic;

/****************************************************************************
 Prototypen

 ****************************************************************************/

/**** ALERTBOX.C ************************************************************/
INT     WinAlert ( INT defaultexitbut, BYTE *s );

/**** CLIPBRD.C *************************************************************/
VOID    HandleClipboard ( HWND hwnd, INT keycode, INT kb );
BOOL    GetClipboard ( BYTE *scrapdir );
VOID    ClearClipboard ( BYTE *scrapdir );

/**** DATUM.C ***************************************************************/
VOID    InitDateModul( VOID );                    /* Modul initialisieren */
char   *GetDate( char *s );                       /* Akt. Datum -> s */
VOID    GetMonthLength( INT ml[] );               /* Feld mit Monatslaengen fuellen */
INT     TageImMonat( int Monat, int Jahr );     	/* Laenge eines Monats holen */

void    get_date( char *t );                      /* 17021965 -> 17.02.1965 */
void    Get_date( char *t );                      /* 17.02.1965 -> 17021965 */
void    make_date( char *s, int diff );           /* 17021965 um diff Tage ndern */
void    eng_dat( char *dest, char *s );           /* 17021965 -> 19650217 */
BYTE   *FormatDate ( BYTE *date, WORD fmt );      /* 17021965 -> 17.02.1965 nach fmt */
VOID    FormatDatum( BYTE *datum, int DateFmt );  /* Nur die Trennzeichen einfgen */

UINT    GetDateINT( VOID );                       /* holt Datum im GEMDOS-Format
                                                     0-4  Tag (1-31)
                                                     5-8  Monat (1-12)
                                                     9-15 Jahr (0-119, 0= 1980) */
BYTE   *FormatDateINT( BYTE *s, INT date );


void    DateToStr( int date, long _IDT, char *s );/* Gemdosformat -> IDT-Format */
int     DATEtoDate ( char *str );                 /* Pure C -> GEMDOS-Format */

BOOL    ValidateDatum( BYTE *datum );             /* Datum TTMMJJJJ gueltig? */
BOOL    IsLeapYear( INT jahr );                   /* Schaltjahr? */

INT     GetDay( VOID );                           /* akt. Tag holen */
INT     GetMonth( VOID );                         /* akt. Monat holen */
INT     GetYear( VOID );                          /* akt. Jahr holen 4-stellig */
INT     GetYearShort( VOID );                     /* akt. Jahr holen 2-stellig */

VOID    SetDateMask(  OBJECT *tree, WORD objc, WORD form );
VOID    DateToString( BYTE *string, BYTE *date, WORD fmt );
VOID    StringToDate( BYTE *date, BYTE *string, WORD fmt );

int 		TageSeitNeujahr( int nTag, int nMonat, int nJahr );
int 		Woche( int nTag, int nMonat, int nJahr );
int 		Wochentag( long lTag, long lMonat, long lJahr );

/**** DIALOG.C **************************************************************/
HWND    CreateDialog( OBJECT *dialog, char *title, int *x, int *y,
                      EVENTFUNC Event, OBJECT *menu, MENUEVENTFUNC MenuEvent );
INT     DoModal( OBJECT CONST *dialog, char *title, EVENTFUNC Event );
WORD    DoDialog( OBJECT *tree );
VOID    HandleModalDialog( HWND hwnd );

/**** DIVERS.C **************************************************************/
INT     InitNewlib( char *name, INT use3d );
VOID    ExitNewlib( void );
INT     gem_init( char * );
int     gem_exit( void );
VOID    PostQuitMessage( INT );
void    settext(OBJECT * tree,int objc,const char *s);
long    get_ram(int modus);
void    get_fonts(void);
void    set_state( OBJECT *tree, int objc, int value );
unsigned long get_checksum(char *s);
char   *get( char *dest, char *s );
char   *Get( char *dest, char *s, int maxlen );
void    beg_update(void);
void    end_update(void);
VOID    KillBlanks( BYTE *s );
int     CountTree(OBJECT *tree);
VOID    xywh2rect (WORD x,WORD y,WORD  w,WORD  h,RECT * rect);
VOID 		array2rect( INT *px, RECT *rect );
VOID    iputchar( IOREC* piorec, UBYTE c );
WORD    Replace( BYTE *s, BYTE *v, BYTE *d);
BOOL    RC_Intersect( GRECT *r1, GRECT *r2 );
void    clipping( /*int x, int y, int w, int h,*/ int mode );
void    Clip( int, int);
BOOLEAN background ( OBJECT *tree, WORD obj, BOOLEAN get, MFDB *screen, MFDB *buffer );
INT     IsEscapeKey( VOID );

/* 29.10.99: tree entfernt, da dieser in modalen Dialogen kopiert wird und sonst die Position des
             Popups nicht stimmt */
WORD    PopupSelect ( HWND hwnd, /*OBJECT *tree,*/ WORD btn, OBJECT *poptree, WORD obj, BOOLEAN docheck, WORD docycle );

WORD    PopupMenu ( HWND hwnd, OBJECT *tree, WORD obj, WORD x, WORD y, WORD center_obj, BOOLEAN relative, WORD bmsk );
bfobspec *get_bfobspec(OBJECT *tree, WORD obj);
int 		Vst_arbpt( int handle, long point, int *chwd, int *chht, int *cellwd, int *cellht );

/**** FILE.C ****************************************************************/
int     fsel(char *name,char *titel,char *ext);
boolean exist(char *s);
long    FileLength(char *s);
int     backup(char *s);
int     backupTmp(char *s);
WORD    CopyFile( BYTE *d, BYTE *s );
WORD    FileExtender( BYTE *file, BYTE *extender );
void    get_file( char *name );      /* Dateinamen aus Pfad fischen */

/**** FILEIO.C **************************************************************/
int     file_creat( char *filename );
int     file_open( char *filename, int access, ... );
int     file_close( int handle );
size_t  file_lseek( int handle, size_t offset, int whence );
size_t  file_read( int handle, void *buf, size_t len );
size_t  file_write( int handle, void *buf, size_t len );

FILE   *file_fopen( const char *filename, const char *mode );
int     file_fclose( FILE *stream );
int     file_fseek( FILE *stream, long offset, int mode );
size_t  file_fread( void *ptr, size_t elem_Size, size_t count, FILE *stream );
size_t  file_fwrite( const void *buf, size_t elem_Siz, size_t count, FILE *stream );
int     file_fputs( const char *s, FILE *fp );
char   *file_fgets( char *str, int n, FILE *fp );
int     file_fprintf( FILE *stream, const char *format, ... );
int     file_fflush( FILE *stream );

INT     FileIOError( BYTE *filename, int errno );

/**** FONTS.C ***************************************************************/
HWND    FontBox( BYTE *wintitle, HWND hwndDest, INT fontid, INT fh, INT prop );
VOID    InitFontbox( WORD *x, WORD *y );     /* Modul initialisieren */
INT 		SetWindowFontAndPoints( HWND hwnd, int id, int points );

/**** GADGET.C **************************************************************/
VOID    SelectButton( HWND hwnd, INT button );
VOID    DeSelectButton( HWND hwnd, INT button );

/**** GRAF.C ****************************************************************/
void    GrafRubberbox( HWND, int bx, int by, int bw, int bh,
                       void(*func)( HWND, int *, int, int ));
WORD    GrafDragbox( WORD *pxy, RECT *b);

/**** ICONIFY.C *************************************************************/
VOID    UnIconifyWindow( HWND hwnd );

/**** KEYCODE.C *************************************************************/
VOID    EdChar( HWND hwnd, INT kb, KEYTAB *keytab, int keycode );
VOID    ObjectEdit( HWND hwnd, int keycode, int on );
VOID    DoDefaultKey( HWND hwnd );
void    CursorToPosition( HWND hwnd, int pos );

/**** LOADCFG.C *************************************************************/
VOID    WP_UnLoadCFG( VOID ); /* gibt den Speicher wieder frei */
INT     WP_LoadCFG( BYTE *pathname );
VOID    WP_ControlPrinter( LONG handle, CFG_CTRLS control );
WORD    WP_PrintChar( long handle, UWORD zeichen );

/**** MENU.C ****************************************************************/
VOID    MenuNormal( HWND hwnd, WORD title, BOOLEAN normal );
WORD    GetTitle( OBJECT *tree, WORD item );
WORD    FindTitle( OBJECT *menu, BYTE *string );
WORD    FindMenuEntry( OBJECT *menu, BYTE *string );
VOID    FixMenu ( HWND hwnd );
int     CreateMenu( HWND hwnd, OBJECT *menu, BOOLEAN on );
VOID    DisableMenu( HWND hwnd, OBJECT *menu, int True );
INT 		MenuAttach( int me_flag, OBJECT *me_tree, int me_item, MENU *me_mdata );

/**** MESSAGE.C *************************************************************/
VOID    GetMessage( INT msgtype );

/**** MOUSE.C ***************************************************************/
void    BusyMouse( int );
void    Mouse( int style );
void    UserMouse( int );

/**** NL_EVENT.C ************************************************************/
void    MultiEvent(void);

/**** OUTPUT.C **************************************************************/
LONG 		OpenDevice( int devicenr, int which, char *filename, int leftborder,
                    int font, long fh, int docx, int docy, RECT *r, BYTE *port );
VOID 		CloseDevice( int which, long handle );
void    vdi_text( long handle, int xpos, int ypos, char *text );
INT     Getbh( VOID );
INT     Getbw( VOID );

INT     IsPrinterPortReady( VOID );

/**** REDRAW.C **************************************************************/
/* Bereich in Fenster ber Rechteckliste ausgeben */
VOID    Redraw( HWND hwnd, INT x, INT y, INT w, INT h );

/* Button in Fenster ber Rechteckliste ausgeben */
VOID    DrawButton( HWND hwnd, INT objc );

/* Ein Rechteck im Dialogfenster ungeklippt ausgeben */
void    RedrawDialogWin( HWND hwnd, int flag, int x, int y, int w, int h);

/* Ein Rechteck im Bildfenster ungeklippt ausgeben */
VOID    RedrawPictureWin( HWND hwnd, INT flag, INT x, INT y, INT w, INT h );

/* Alle Fenster ber Rechteckliste neu ausgeben */
void    RedrawAllWindows( void );

/**** RTSLIDE.C *************************************************************/
VOID 		RtSliderInit( OBJECT *tree, WORD closer, WORD head, WORD edge,
                      WORD vbox, WORD vslbox, WORD up, WORD down, WORD hbox,
                      WORD hslbox, WORD left, WORD right );
void    DoRealtimeSlide( OBJECT *tree, int back_index, int slider_index,
                         int slider_type,int (*call_func)(int new_pos) );
void    DoRtBack ( int clicks, OBJECT *tree, int back, int slide, LONG count,
                   int view, LONG *start,void(*out)(int,LONG));
void    DoRtSlide( HWND hwnd, int back_index, int slider_index,
                   int slider_type,LONG *start,LONG count,int view,
                   void(*out)(int,LONG),int OBJ1,int OBJLAST,int w);
VOID    RtUpDownScroll( HWND hwnd, WORD clicks, WORD flag, WORD page,OBJECT *tree,
                        WORD view, LONG *start, LONG count, WORD N1, WORD N2,
                        WORD NLAST, WORD w, VOID(*out)(int,LONG), WORD slide);
void    RtSlider ( OBJECT *tree, int slider, LONG start, LONG count, int view,
                   int draw );
void    RtSliderSize ( OBJECT *tree, int slider, LONG count, int view );
VOID    DrawRtListBox( INT flag, HWND hwnd, OBJECT *tree, INT BoxObj,
                       INT SlideObj, LONG start, LONG count, INT view );

/**** SCROLL.C **************************************************************/
WORD    ScrollWinKeyEvent( HWND hwnd, KEYTAB *keytab, int kb, int keycode);

/**** TEXTWIN.C *************************************************************/
/* Redraw-Funktion */
VOID    ListRedraw( HWND hwnd, int flag, int x, int y, int w, int h);

/* Listenmanipulation */
INT     AddListe( HWND hwnd );
VOID    InitListe( HWND hwnd );
VOID    FreeList( HWND hwnd );
VOID  	DeSelectTextList( HWND hwnd );

/* Cursormanipulation */
VOID    WindowCursor( HWND hwnd, BOOLEAN on );

/* Zeile anhngen */
BOOL    AddLine( HWND hwnd, BYTE * s );
BOOL    AddLineColored( HWND hwnd, BYTE * s, int color );

/* Zeile selektieren, setzt aktuelle Zeile */
VOID    SelectTextLine( HWND hwnd, LONG line, int sel );

/* Zeilen per Schleife abfragen, setzt aktuelle Zeile */
BYTE 	 *GetFirstTextLine( HWND hwnd );
BYTE 	 *GetLastTextLine( VOID );
BYTE 	 *GetNextTextLine( VOID );
BYTE 	 *GetPrevTextLine( VOID );

/* von aktuellen Zeile die Flags bearbeiten */
INT   	GetTextLineFlag( HWND hwnd );
VOID  	SetTextLineFlag( HWND hwnd, int flags );
VOID  	DelTextLineFlag( HWND hwnd, int flags );

/* aktuelle Zeile Text holen */
BYTE 	 *GetTextLine( HWND hwnd );

/* Anzahl selektierter Zeilen abfragen */
LONG  	GetSelectedTextLines( HWND hwnd );

/* Zeichen einfgen */
INT  	  InsertChar( BYTE c, INT pos, INT overwrite );

/* Zeilenmanipulation ueber Pointer, z.B. zum Sortieren */
BYTE 	 *GetFirstTextLinePtr( HWND hwnd, BYTE ** );
BYTE   *GetNextTextLinePtr( BYTE ** );
BYTE   *SetAktTextLinePtr( BYTE * );

/**** USERDEF.C *************************************************************/
VOID    ExtendObjects( OBJECT *tree );
void    extend_objects( OBJECT *tree );

/**** WINDOWS.C *************************************************************/
/* Fenster nach oben bringen */
BOOL    BringWindowToTop( HWND hwnd );

/* Fenster komplett loeschen */
BOOL    DestroyWindow( HWND hwnd );

/* Fenster verschieben */
BOOL    MoveWindow( HWND hwnd, INT x, INT y, INT w, INT h, BOOL Repaint );

/* wenn das oberste Fenster ein eigenes ist wird dieses handle returned */
HWND    GetTopWindow( HWND hwnd );

/* Fenster anhand des Fensterclassennamens finden */
HWND    FindWindow( BYTE *ClassName, BYTE *Name );

/* Redraw-Message fuer Fenster erzeugen */
BOOL    RedrawWindow( HWND hwnd, RECT *area, HRGN hrgn, UINT Redraw );

/* Ganzes Fenster ber Rechteckliste neu ausgeben */
VOID    UpdateWindow( HWND hwnd );

VOID    SetWindowRtScroll( HWND hwnd, RTSCROLL RtScroll );

VOID    SetWindowText( HWND hwnd, BYTE *title );
VOID    SetWindowVdihandle( HWND hwnd, INT handle );
INT     GetWindowVdihandle( HWND hwnd );
BYTE   *GetWindowText( HWND hwnd );
VOID   *WindowUserdef( HWND hwnd );
VOID    SetWindowClassName( HWND hwnd, BYTE *ClassName );
BYTE   *GetWindowClassName( HWND hwnd );
HWND    FindWindowTree( OBJECT *dialog );
VOID    SetWindowIconHandle( HWND hwnd, INT handle );
VOID    SetWindowIdx( HWND hwnd, INT idx );
INT     GetWindowIdx( HWND hwnd );
VOID    SetWindowEditObject( HWND hwnd, INT EditObject );
INT     GetWindowEditObject( HWND hwnd );
VOID    SetWindowNextObject( HWND hwnd, INT EditObject );
INT     GetWindowNextObject( HWND hwnd );
OBJECT *GetWindowMenu( HWND hwnd );
VOID    SetWindowTree( HWND hwnd, OBJECT *tree );
OBJECT *GetWindowTree( HWND hwnd );
VOID    SetWindowToolbar( HWND hwnd, OBJECT *tree );
OBJECT *GetWindowToolbar( HWND hwnd );
INT     WindowEvent( HWND hwnd, INT objc, INT clicks );
VOID    WindowRedraw( HWND hwnd, INT flag, INT x, INT y, INT w, INT h );
VOID    SetWindowKeyEvent( HWND hwnd, INT ( *wkey_event )( HWND, KEYTAB *, INT, INT ));
VOID    SetWindowRedraw( HWND hwnd, REDRAWFUNC Redraw );
VOID    SetWindowEvent( HWND hwnd, EVENTFUNC EventFunc );
VOID    SetWindowDestructor( HWND hwnd, VOID ( *Destructor )( HWND hwnd));
VOID    SetWindowMenuEvent( HWND hwnd, MENUEVENTFUNC MenuEvent );
VOID    SetWindowLines( HWND hwnd, LONG lines );
LONG    GetWindowLines( HWND hwnd );
VOID 		SetWindowCw( HWND hwnd, INT cw );
INT 		GetWindowCw( HWND hwnd );
VOID 		SetWindowCh( HWND hwnd, INT ch );
INT 		GetWindowCh( HWND hwnd );
LONG 		GetWindowRw( HWND hwnd );
VOID 		SetWindowRw( HWND hwnd, INT lh );
LONG 		GetWindowLh( HWND hwnd );
VOID 		SetWindowLh( HWND hwnd, INT lh );
VOID    SetWindowYOffset( HWND hwnd, INT offset );
INT 		GetWindowYOffset( HWND hwnd );
VOID    SetWindowFirstLine( HWND hwnd, LONG line );
LONG    GetWindowFirstLine( HWND hwnd );
VOID    SetWindowFirstRow( HWND hwnd, LONG row );
LONG    GetWindowFirstRow( HWND hwnd );
VOID    SetWindowEditFlag( HWND hwnd, INT flag );
INT     GetWindowEditFlag( HWND hwnd );
INT     GetWindowOn( HWND hwnd );
VOID 		SetWindowColor( HWND hwnd, INT color );
INT 		GetWindowColor( HWND hwnd );
VOID    SetWindowFont( HWND hwnd, INT font );
INT     GetWindowFont( HWND hwnd );
VOID    SetWindowFontheight( HWND hwnd, INT fh );
INT     GetWindowFontheight( HWND hwnd );
VOID    SetWindowFile( HWND hwnd, BYTE *title );
BYTE   *GetWindowFile( HWND hwnd );
VOID    SetWindowIndex( HWND hwnd, INT index );
INT     GetWindowIndex( HWND hwnd );
INT     GetWindowType( HWND hwnd );
INT     SetWindowStatus( HWND hwnd, INT status );
INT     GetWindowStatus( HWND hwnd );
VOID    CloseWindows( WORD close );
HWND    CreateWindow( BYTE *class, BYTE *name, INT typ, INT *x, INT *y, INT *w, INT *h,
                      MOUSEEVENTFUNC MouseEvent, OBJECT *menu, MENUEVENTFUNC MenuEvent,
                      REDRAWFUNC Redraw, EVENTFUNC Event );
BOOL    IsWindowOpen( VOID );
HWND    GetFirstWindow( VOID );
HWND    GetNextWindow( VOID );
BOOL    GetOldWindowRect ( HWND hwnd, GRECT *r );
VOID    CascadeWindows( VOID );
VOID 		WindowDestructor( HWND hwnd );

/**** XACC.C ****************************************************************/
int     send_text( WORD ap_id, WORD destination, char *s );  /* Text s senden */
void    init_xapps( int clear );                             /* xapps initialisieren */

/**** XRSRC.C ***************************************************************/
/**** XRSRCFIX.C ************************************************************/
BOOLEAN rsc_init_xrsrc(WORD vdi_handle, GRECT *desk, WORD gl_wbox, WORD gl_hbox);
VOID    init_xrsrc(WORD vdi_handle, OBJECT *object, WORD num_obs, WORD num_cib, WORD palette[][4]);
WORD    xrsrc_load(CONST BYTE *re_lpfname, WORD *pglobal);
WORD    xrsrc_gaddr(WORD re_gtype, WORD re_gindex, VOID *re_gaddr, WORD *pglobal);
WORD    xrsrc_free(WORD *pglobal);
VOID    term_xrsrc _((WORD num_cib));
VOID    fix_objs _((OBJECT  *tree));

#endif
