#ifndef __GRAFLIB__
#define __GRAFLIB__

/****************************************************************************
 
 Imageheader                                                              
 
 ****************************************************************************/
typedef struct {
	unsigned version;        
	unsigned headlen;       /* Headerlaenge */
	unsigned nplanes;
	unsigned patlen;
	unsigned pixelw;        /* Pixelbreite  */
	unsigned pixelh;        /* Pixelhoehe   */
	unsigned linew;         /* Zeilenbreite */
	unsigned lines;         /* Zeilenanzahl */
} IMGHEADER;

/****************************************************************************/
/*                                                                          */
/* Degasheader                                                              */ 
/*                                                                          */
/****************************************************************************/
typedef struct {
	char version;        /* muss 0 sein            */
	char id;             /* mono:2; med:1 ; low: 0 */
  char palette[32];    /* Farbpalette            */    
} DEGASHEADER;

/****************************************************************************/
/*                                                                          */
/* NEOCHROME-Header                                                         */
/*                                                                          */
/****************************************************************************/
typedef struct {
  int  flag   ;        /* flag byte (immer 0) */
  int  resolution;     /* 0-2                 */
  int  rgb[16];        /* Farbepalette        */
  char name[12];       /* Bildname            */
  int  colanim;
  int  colspeed;
  int  colstep;
  int  xoff;
  int  yoff;
  int  w;              /* Breite              */
  int  h;              /* Hoehe               */
  int  reserve[33];
} NEOHEADER;

/**** GRAFIK.C *************************************************************/

int     un_pac( long bytes, unsigned char *source, unsigned char *dest );
boolean save_iff( void );
int     save_compressed_image( char *file, int w, int h, int bpl, unsigned char *buffer );
void    mbitblt( int x, int y, int w, int h, unsigned char *mem, int mode, int flag );
void    vr_convert( MFDB *src, int format );

#endif